<?php
class ControllerExtensionPaymentRukassa extends Controller {
    private $error = array();

    public function index()
    {
        $this->load->language('extension/payment/rukassa');
        $this->document->setTitle($this->language->get('heading_title'));
        $this->load->model('setting/setting');

        if (($this->request->server['REQUEST_METHOD'] == 'POST') && $this->validate()) {
            $this->model_setting_setting->editSetting('payment_rukassa', $this->request->post);
            $this->session->data['success'] = $this->language->get('text_success');
            $this->response->redirect($this->url->link('marketplace/extension', 'user_token=' . $this->session->data['user_token'] . '&type=payment', true));
        }

        $data['heading_title'] = $this->language->get('heading_title');

        $data['text_all_zones'] = $this->language->get('text_all_zones');
        $data['text_payment'] = $this->language->get('text_payment');
        $data['text_success'] = $this->language->get('text_success');
        $data['text_edit'] = $this->language->get('text_edit');
        $data['text_pay'] = $this->language->get('text_pay');
        $data['text_enabled'] = $this->language->get('text_enabled');
        $data['text_disabled'] = $this->language->get('text_disabled');
        $data['text_rukassa'] = $this->language->get('text_rukassa');
        $data['text_email_subject'] = $this->language->get('text_email_subject');
        $data['text_email_message1'] = $this->language->get('text_email_message1');
        $data['text_email_message2'] = $this->language->get('text_email_message2');
        $data['text_email_message3'] = $this->language->get('text_email_message3');
        $data['text_email_message4'] = $this->language->get('text_email_message4');
        $data['text_email_message5'] = $this->language->get('text_email_message5');
        $data['text_email_message6'] = $this->language->get('text_email_message6');

        $data['entry_merchant_id'] = $this->language->get('entry_merchant_id');
        $data['entry_secret_key_1'] = $this->language->get('entry_secret_key_1');
        $data['entry_secret_key_2'] = $this->language->get('entry_secret_key_2');
        $data['entry_order_wait'] = $this->language->get('entry_order_wait');
        $data['entry_order_success'] = $this->language->get('entry_order_success');
        $data['entry_order_fail'] = $this->language->get('entry_order_fail');
        $data['entry_geo_zone'] = $this->language->get('entry_geo_zone');
        $data['entry_status'] = $this->language->get('entry_status');
        $data['entry_sort_order'] = $this->language->get('entry_sort_order');
        $data['entry_status_url'] = $this->language->get('entry_status_url');
        $data['entry_success_url'] = $this->language->get('entry_success_url');
        $data['entry_fail_url'] = $this->language->get('entry_fail_url');
        $data['entry_notification_url'] = $this->language->get('entry_notification_url');
        $data['entry_success_url'] = $this->language->get('entry_success_url');
        $data['entry_fail_url'] = $this->language->get('entry_fail_url');

        $data['error_permission'] = $this->language->get('error_permission');
        $data['error_merchant_id'] = $this->language->get('error_merchant_id');
        $data['error_secret_key'] = $this->language->get('error_secret_key');

        $data['help_merchant'] = $this->language->get('help_merchant');
        $data['help_secret_key'] = $this->language->get('help_secret_key');

        $data['button_save'] = $this->language->get('button_save');
        $data['button_cancel'] = $this->language->get('button_cancel');

        if (isset($this->error['warning'])) {
            $data['error_warning'] = $this->error['warning'];
        } else {
            $data['error_warning'] = '';
        }

        if (isset($this->error['merchant'])) {
            $data['error_merchant_id'] = $this->error['merchant'];
        } else {
            $data['error_merchant_id'] = '';
        }

        if (isset($this->error['security'])) {
            $data['error_secret_key'] = $this->error['security'];
        } else {
            $data['error_secret_key'] = '';
        }

        if (isset($this->error['type'])) {
            $data['error_type'] = $this->error['type'];
        } else {
            $data['error_type'] = '';
        }

        $data['breadcrumbs'] = array();

        $data['breadcrumbs'][] = array(
            'text' => $this->language->get('text_home'),
            'href' => $this->url->link('common/dashboard', 'user_token=' . $this->session->data['user_token'], true)
        );

        $data['breadcrumbs'][] = array(
            'text' => $this->language->get('text_payment'),
            'href' => $this->url->link('marketplace/extension', 'user_token=' . $this->session->data['user_token'] . '&type=payment', true)
        );

        $data['breadcrumbs'][] = array(
            'text' => $this->language->get('heading_title'),
            'href' => $this->url->link('extension/payment/rukassa', 'user_token=' . $this->session->data['user_token'], true)
        );

        $data['action'] = $this->url->link('extension/payment/rukassa', 'user_token=' . $this->session->data['user_token'], true);

        $data['cancel'] = $this->url->link('marketplace/extension', 'user_token=' . $this->session->data['user_token'] . '&type=payment', true);

        if (isset($this->request->post['payment_rukassa_merchant_id'])) {
            $data['payment_rukassa_merchant_id'] = $this->request->post['payment_rukassa_merchant_id'];
        } else {
            $data['payment_rukassa_merchant_id'] = $this->config->get('payment_rukassa_merchant_id');
        }

        if (isset($this->request->post['payment_rukassa_secret_key_1'])) {
            $data['payment_rukassa_secret_key_1'] = $this->request->post['payment_rukassa_secret_key_1'];
        } else {
            $data['payment_rukassa_secret_key_1'] = $this->config->get('payment_rukassa_secret_key_1');
        }
		
        if (isset($this->request->post['payment_rukassa_order_wait_id'])) {
            $data['payment_rukassa_order_wait_id'] = $this->request->post['payment_rukassa_order_wait_id'];
        } else {
            if (!$this->config->get('payment_rukassa_order_wait_id')) {
                $data['payment_rukassa_order_wait_id'] = 1;
            } else {
                $data['payment_rukassa_order_wait_id'] = $this->config->get('payment_rukassa_order_wait_id');
            }
        }
        if (isset($this->request->post['payment_rukassa_status'])) {
            $data['payment_rukassa_status'] = $this->request->post['payment_rukassa_status'];
        } else {
            if (!$this->config->get('payment_rukassa_status')) {
                $data['payment_rukassa_status'] = 1;
            } else {
                $data['payment_rukassa_status'] = $this->config->get('payment_rukassa_status');
            }
        }
        if (isset($this->request->post['payment_rukassa_order_success_id'])) {
            $data['payment_rukassa_order_success_id'] = $this->request->post['payment_rukassa_order_success_id'];
        } else {
            if (!$this->config->get('payment_rukassa_order_success_id')) {
                $data['payment_rukassa_order_success_id'] = 5;
            } else {
                $data['payment_rukassa_order_success_id'] = $this->config->get('payment_rukassa_order_success_id');
            }
        }

        if (isset($this->request->post['payment_rukassa_order_fail_id'])) {
            $data['payment_rukassa_order_fail_id'] = $this->request->post['payment_rukassa_order_fail_id'];
        } else {
            if (!$this->config->get('payment_rukassa_order_fail_id')) {
                $data['payment_rukassa_order_fail_id'] = 10;
            } else {
                $data['payment_rukassa_order_fail_id'] = $this->config->get('payment_rukassa_order_fail_id');
            }
        }

        $this->load->model('localisation/order_status');

        $data['order_statuses'] = $this->model_localisation_order_status->getOrderStatuses();

        if (isset($this->request->post['payment_rukassa_geo_zone_id'])) {
            $data['payment_rukassa_geo_zone_id'] = $this->request->post['payment_rukassa_geo_zone_id'];
        } else {
            $data['payment_rukassa_geo_zone_id'] = $this->config->get('payment_rukassa_geo_zone_id');
        }

        $this->load->model('localisation/geo_zone');

        $data['geo_zones'] = $this->model_localisation_geo_zone->getGeoZones();

        if (isset($this->request->post['payment_rukassa_sort_order'])) {
            $data['payment_rukassa_sort_order'] = $this->request->post['payment_rukassa_sort_order'];
        } else {
            $data['payment_rukassa_sort_order'] = $this->config->get('payment_rukassa_sort_order');
        }

        if (isset($this->request->post['payment_rukassa_notification_url'])) {
            $data['payment_rukassa_notification_url'] = $this->request->post['payment_rukassa_notification_url'];
        } else {
            if (!$this->config->get('payment_rukassa_notification_url')) {
                $data['payment_rukassa_notification_url'] = ((!empty($_SERVER['HTTPS'])) ? 'https' : 'http') . '://' . $_SERVER['HTTP_HOST'] . '/index.php?route=extension/payment/rukassa/status';
            } else {
                $data['payment_rukassa_notification_url'] = $this->config->get('payment_rukassa_notification_url');
            }
        }

        if (isset($this->request->post['payment_rukassa_success_url'])) {
            $data['payment_rukassa_success_url'] = $this->request->post['payment_rukassa_success_url'];
        } else {
            if (!$this->config->get('payment_rukassa_success_url')) {
                $data['payment_rukassa_success_url'] = ((!empty($_SERVER['HTTPS'])) ? 'https' : 'http') . '://' . $_SERVER['HTTP_HOST'] . '/index.php?route=extension/payment/rukassa/success';
            } else {
                $data['payment_rukassa_success_url'] = $this->config->get('payment_rukassa_success_url');
            }
        }

        if (isset($this->request->post['payment_rukassa_fail_url'])) {
            $data['payment_rukassa_fail_url'] = $this->request->post['payment_rukassa_fail_url'];
        } else {
            if (!$this->config->get('payment_rukassa_fail_url')) {
                $data['payment_rukassa_fail_url'] = ((!empty($_SERVER['HTTPS'])) ? 'https' : 'http') . '://' . $_SERVER['HTTP_HOST'] . '/index.php?route=extension/payment/rukassa/fail';
            } else {
                $data['payment_rukassa_fail_url'] = $this->config->get('payment_rukassa_fail_url');
            }
        }

        $data['header'] = $this->load->controller('common/header');
        $data['column_left'] = $this->load->controller('common/column_left');
        $data['footer'] = $this->load->controller('common/footer');

        $this->response->setOutput($this->load->view('extension/payment/rukassa', $data));
    }

    protected function validate(){

        if (!$this->user->hasPermission('modify', 'extension/payment/rukassa')) {
            $this->error['warning'] = $this->language->get('error_permission');
        }

        if (!$this->request->post['payment_rukassa_merchant_id']) {
            $this->error['merchant'] = $this->language->get('error_merchant_id');
        }

        if (!$this->request->post['payment_rukassa_secret_key_1']) {
            $this->error['security'] = $this->language->get('error_secret_key');
        }

        return !$this->error;
    }
}